<script setup lang="ts">
import { defineProps, ref } from 'vue';

defineOptions({
  name: 'PostCard'
});

export interface PostCardProps {
  post: {
    id: string;
    date: string;
    link: string;
    likes: number;
    comments: number;
    message?: string;
    image?: string;
    author: {
      name: string;
      username: string;
      avatar: string;
    }
  };
}

defineProps<PostCardProps>();

const expanded = ref(false);
const text = ref('');
</script>

<template>
  <q-card class="bg-primary q-mb-lg">
    <q-card-section class="row">
      <q-avatar>
        <q-img src="https://cdn.quasar.dev/img/avatar.png" />
      </q-avatar>
      <q-item clickable tag="a" :href="post.link" class="col">
        <q-item-section>
          <q-item-label class="text-h5">
            {{ post.author.name }}
            <span class="text-caption"> @{{ post.author.username }}</span>
          </q-item-label>
          <q-item-label>{{ post.message }}</q-item-label>
          <q-item-label caption>{{ post.date }}</q-item-label>
        </q-item-section>
      </q-item>

      <q-btn flat icon="more_vert" >
        <q-menu
          transition-show="jump-down"
          transition-hide="jump-up"
          :style="{ backgroundColor: 'var(--q-secondary)', color: 'white'}"
        >
          <q-list style="min-width: 100px">
            <q-item clickable>
              <q-item-section>
                Partager
              </q-item-section>
            </q-item>
            <q-item clickable>
              <q-item-section>
                Sauvegarder
              </q-item-section>
            </q-item>
            <q-item clickable>
              <q-item-section>
                Copier le lien
              </q-item-section>
            </q-item>
            <q-item clickable>
              <q-item-section>
                Masquer
              </q-item-section>
            </q-item>
            <q-separator />
            <q-item clickable>
              <q-item-section>
                Signaler
              </q-item-section>
            </q-item>
          </q-list>
        </q-menu>
      </q-btn>
    </q-card-section>
    <q-card-section>
      <q-img :src="post.image" :ratio="16/9" style="border-radius: 8px;" class=""/>
    </q-card-section>
    <q-card-section>
      <div class="row">
        <q-card-actions align="left" class="col">
          <q-btn flat round color="red" icon="comment"
                 @click="expanded = !expanded"
          >
            <q-badge color="red" floating>
              {{ post.comments }}
            </q-badge>
          </q-btn>
          <q-btn flat round color="red" icon="favorite" />
        </q-card-actions>

        <q-card-actions align="right" class="col">
          <q-btn flat round color="teal" icon="bookmark" />
          <q-btn flat round color="white" icon="share" />
        </q-card-actions>
      </div>
    </q-card-section>

    <q-slide-transition>
      <div v-show="expanded">
        <q-separator />

        <div class="q-pa-md row justify-center">
          <div style="width: 100%;">
            <q-chat-message
              label="Sunday, 19th"
            />

            <q-chat-message
              name="me"
              avatar="https://cdn.quasar.dev/img/avatar4.jpg"
              :text="['hey, how are you?']"
              sent
              stamp="7 minutes ago"
            />
            <q-chat-message
              name="Jane"
              avatar="https://cdn.quasar.dev/img/avatar3.jpg"
              :text="['doing fine, how r you?']"
              stamp="4 minutes ago"
            />
          </div>
        </div>

        <div class="q-ma-lg">
          <q-input
            v-model="text"
            filled
            clearable
            type="text"
            color="secondary"
            bg-color="white"
            label="Commenter ce post"
          />

          <div class="flex justify-end">
            <q-btn color="secondary" icon="person" label="Commenter" class="q-mb-xs q-mt-xs" />
          </div>
        </div>
      </div>
    </q-slide-transition>
  </q-card>
</template>

<style scoped>

</style>
